#include "geotraceman.h"

void readmap()
{
	int x;
	int y;
	int i, j;
	int  ibuffer[2];
	FILE *ifile;

	for(i=0; i < Yregions; i++) {
		for(j=0; j < Xregions; j++) {	
			regions[i][j].nvect = 0;
		}
	}

	/* Open the file and check that it opened ok */
	ifile = fopen(Cil_Map_File_Names[0], "r");

	/* Input each region from the file */
	for(y=0; y < Yregions; y++) {
		for (x=0; x < Yregions; x++) {
			/* Input the number of vectors in a region */
			fread(&regions[y][x].nvect, sizeof(int), 1, ifile);

			/* Get the number of segments in each vector */
			fread(regions[y][x].nseg, sizeof(unsigned char), regions[y][x].nvect, ifile);

			/* For each vector read in its segments */
			for(i=0; i < regions[y][x].nvect; i++) 
				fread(regions[y][x].line[i], sizeof(unsigned char), (regions[y][x].nseg[i] * 2), ifile);

		}
	}
	 
	fclose(ifile);
}

/*
Determines the physical region delimiter that is associated with a logical value delimiter
*/
int update_region_delimiter2(ms, value, max, x_delimiter)
	Map_State_Struct ms;
	long value;	
	Boolean max;
	Boolean x_delimiter;
{
	int temp;

	temp = value / ms.region_range;	
	
	if ((max == TRUE) && (temp < (ms.side_size - 1)))	
		temp++;

	if (x_delimiter) {	
		temp += ms.x_reg_offset;

		if (temp < 0)
			temp = ms.side_size - temp;
		else if (temp > (ms.side_size - 1))
			temp = temp - ms.side_size;
	}
}

/*
Passed the regions, and the current map state, outputs the regions to the screen
*/
void output_regions(ms, regs)
	Map_State_Struct ms;
	Reg *regs;
	
{
	int         x,y,i,j;
    	unsigned char *line;
    	long	values[2]; 
	Reg *reg;
	long leftregbdr;
	long leftregbdr2;
	Boolean drawtwice;

    	for(x = ms.x.min_vis_reg; x <= ms.x.max_vis_reg; x++) {
		drawtwice = FALSE;
		leftregbdr = (x + ms.x_reg_offset) * ms.region_range;
		if (leftregbdr  > ((ms.side_size - 1) * ms.region_range)) {
			if ((leftregbdr + ms.region_range) < ms.x.max_vis) {
				leftregbdr2 = leftregbdr;
				drawtwice = TRUE;
			}
			leftregbdr -= ms.max_range;
		}
		else if (leftregbdr < 0) {
			if ((leftregbdr + ms.region_range) > 0) {
				leftregbdr2 = leftregbdr;
				drawtwice = TRUE;
			}

			leftregbdr += ms.max_range;
		}

		for(y = ms.y.min_vis_reg; y <= ms.y.max_vis_reg; y++) {	
			reg = &regs[(x * ms.side_size) + y];
    			for (i = 0; i < reg->nvect; ++i) {
        			line = reg->line[i] - 2;
        			bgnline();
        			for (j = 0; j < reg->nseg[i]; ++j) {
               				line += 2;
					values[0] = leftregbdr + (*line);
	       				values[1] = (long) (((int) (*(line + 1))) + (y * ms.region_range)); 
               				v2i(values);
				}

        			endline(); 

    			}
		}

		if (drawtwice) {
			for(y = ms.y.min_vis_reg; y <= ms.y.max_vis_reg; y++) {	
				reg = &regs[(x * ms.side_size) + y];
    				for (i = 0; i < reg->nvect; ++i) {
        				line = reg->line[i] - 2;
        				bgnline();
        				for (j = 0; j < reg->nseg[i]; ++j) {
               					line += 2;
						values[0] = leftregbdr2 + (*line);
	       					values[1] = (long) (((int) (*(line + 1))) + (y * ms.region_range)); 
               					v2i(values);
					}

        				endline(); 

    				}
			}
    		}	
	}
}

int swap_maps(ms,regsp)
	Map_State_Struct *ms;
	Region_Struct **regsp;
{
	free(*regsp);	/* Free the memory held for the previous map structure */
}

void displaymap()
{
	int         x,y,i,j;
    	unsigned char *line;
    	long	values[2]; 
	Reg *reg;
	long leftregbdr;
	long leftregbdr2;
	Boolean drawtwice;

    	for(x=0; x < Xregions; x++) {
		drawtwice = FALSE;
		leftregbdr = (x * Rangeperxregion) + xpanoffset;
		if (leftregbdr  > (Rangeperxregion * (Xregions -1))) {
			leftregbdr2 = leftregbdr - (Rangeperxregion * Xregions);
			drawtwice = TRUE;
		}
		else if (leftregbdr < 0) {
			leftregbdr2 = leftregbdr + (Rangeperxregion * Xregions);
			drawtwice = TRUE;
		}

		for(y=0; y < Yregions; y++) {	
			reg = &regions[y][x];
    			for (i = 0; i < reg->nvect; ++i) {
        			line = reg->line[i] - 2;
        			bgnline();
        			for (j = 0; j < reg->nseg[i]; ++j) {
               				line += 2;
					values[0] = leftregbdr + (*line);
	       				values[1] = (long) (((int) (*(line + 1))) + (y * Rangeperyregion)); 
               				v2i(values);
				}

        			endline(); 

    			}
		}
		
		if (drawtwice == TRUE) {
			for(y=0; y < Yregions; y++) {	
				reg = &regions[y][x];
    				for (i = 0; i < reg->nvect; ++i) {
        				line = reg->line[i] - 2;
        				bgnline();
        				for (j = 0; j < reg->nseg[i]; ++j) {
               					line += 2;
						values[0] = leftregbdr2 + (*line);
	       					values[1] = (long) (((int) (*(line + 1))) + (y * Rangeperyregion)); 
               					v2i(values);
					}

        				endline(); 

    				}
			}
		}

    	}
	swapbuffers();
}
