#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>
#include <netdb.h>
#include <time.h>

#ifdef DEC
#include <sex.h>
#endif

#include <sys/param.h>
#include <sys/time.h>
#include <sys/file.h>
#include <sys/types.h>

#if SUNOS4 || SUNOS5
#include <sys/stropts.h>               /* RMSGD */
#endif

#ifdef SUNOS5
#include <sys/stream.h>
#include <sys/dlpi.h>
#include <sys/bufmod.h>
#include <sys/sockio.h>
#endif

#include <sys/socket.h>
#include <sys/ioctl.h>

#include <net/if.h>

/* packet filter includes */
#ifdef SUNOS4
#include <net/nit.h>
#include <net/nit_if.h>		       /* NIOCBIND */
#include <net/nit_pf.h>		       /* NIOCSETF */
#include <net/nit_buf.h>
#endif

#ifdef DEC
#include <net/pfilt.h>
#endif

#ifdef SGI
#include <net/raw.h>
#endif

#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>

#include "xincludes.h"

/*#include <vogl.h>*/
#include <vodevice.h>

#include "appres.h"

#include "macros.h"
#include "gtypes.h"
#include "gvars.h"

#include "gfuncs.h"

#define WINDOWX			900
#define WINDOWY			750

/* unfortunately, we need to define these here because vogl.h conflicts with
   some of the X Toolkit defs.						    */
/*
 * standard colour indices
 */
#define	BLACK		0
#define	RED		1
#define	GREEN		2
#define	YELLOW		3
#define	BLUE		4
#define	MAGENTA		5
#define	CYAN		6
#define	WHITE		7

/*
 * monochrome colour indices
 */
#define MONO_WHITE	0
#define MONO_BLACK	1

/*
 * zoom levels for differing details (cities and sites
 */
#define ZOOMLEVEL1	1
#define ZOOMLEVEL2	15
#define ZOOMLEVEL3	70

/* 
 * flags for the calling of the UndoMap function
 */
#define ZOOM_SAVE	0
#define ZOOM_UNDO	1
#define ZOOM_CLEAR	2

/*
 * How to convert degrees to radians
 */
#define	PI	3.14159265358979
#define D2R	(PI / 180.0)

/* Geotraceman #defines
 * World limitations latitude and longitude in degree seconds
 */
#define WORLD_MIN_LAT (3600.0 * -90.0)
#define WORLD_MAX_LAT (3600.0 * 90.0) 
#define WORLD_MIN_LONG (3600.0 * -180.0) 
#define WORLD_MAX_LONG (3600.0 * 180.0) 

#define Host_ID_Len 80

#define Map_Levels_Detail 3

static float Map_Swap_Levels[Map_Levels_Detail + 1] = {4.0, 64.0, 256.0, 16000000.0};

#define File_Name_Length 80

/*
Definable constants that maybe should be moved to resources
*/
#define Map_Color_FG WHITE
#define Map_Color_BG BLACK
#define Map_Color_Riv CYAN
#define Map_Color_Pby MAGENTA
#define Map_Color_Cit WHITE
#define Map_Color_Txt YELLOW
#define Map_Color_Dot RED
#define Map_Color_Trace YELLOW

#define Map_Rotation_Fraction 0.10;
#define Initial_Map_Detail 0

#define Map_Directory "./maps/" 

static char Cil_Map_File_Names[Map_Levels_Detail][File_Name_Length] = {
	"gtm_map.cil.4.256.1",
	"gtm_map.cil.32.256.1",
	"gtm_map.cil.256.256.1",
};

static char Riv_Map_File_Names[Map_Levels_Detail][File_Name_Length] = {
	"gtm_map.riv.4.256.1",
	"gtm_map.riv.32.256.1",
	"gtm_map.riv.256.256.1",
};

static char Pdy_Map_File_Names[Map_Levels_Detail][File_Name_Length] = {
	"gtm_map.bdy.4.256.1",
	"gtm_map.bdy.32.256.1",
	"gtm_map.bdy.256.256.1",
};

/*
 * Global widget data
 */
extern Widget  mainPane;                      /* entire window pane */
extern Widget  menuBox;                               /* Form containing commands, etc. *
/
extern Widget  drawingCanvas, sdrawingCanvas;        /* drawing surface */
extern Widget  xpansb, ypansb;
extern Widget  wl_totaldelay, wl_lastdelay, wl_numhosts, wl_tracestatus;
extern Widget  wl_detail, wl_currentzoom, wl_mapstatus;
extern Widget  panner, pannerform;
extern Pixmap  up_arrow, down_arrow, right_arrow, left_arrow;
extern Pixmap  geotraceman_icon;
